<template>
<div>
    <div class="time" v-show="tipTimeShow">
        {{hour}}:{{minute}}:{{second}}
    </div>
</div>
</template>

<script>
export default {
    props: ['startTime'],
    data() {
        return {
            time: null,
            hour: '00',
            minute: '00',
            second: '00',
            tipTimeShow:true  //倒计时为零时隐藏
        };
    },

    components: {},
    mounted() {
      this.handleDiffTime();
    },
    destroyed() {
        clearInterval(this.time)
    },
    computed: {},

    methods: {
        handleDiffTime() {
            this.time && clearInterval(this.time);
            this.time = setInterval(() => {
                let now = new Date().getTime();
                let timestamp = this.startTime - now;
                this.hour = this.handleTime(parseInt(timestamp / 1000 / 60 / 60, 10));
                this.minute = this.handleTime(parseInt(timestamp / 1000 / 60 % 60, 10));
                this.second = this.handleTime(parseInt(timestamp / 1000 % 60, 10));
                if (timestamp <= 0) {
                    this.$emit('end')
                    this.tipTimeShow = false;
                    clearInterval(this.time)
                }
            }, 1000)

        },

        //    处理时间格式
        handleTime(val) {
            if (val < 10) {
                val = '0' + val
            }
            return val;
        }
    },

}
</script>

<style lang="scss" scoped>
.time {
    position: absolute;
     
   
    text-align: center;
    color: #ffffff;
    font-size: .24rem;
   left: 0.3rem;
    top: -0.25rem;
    z-index: 200;
}
</style>
